#ifndef MATCOM_H

#define MATCOM_H

#include <stdbool.h>

typedef char fix_str[256];
typedef struct graph_mco graph_mco;

struct edge {
	int i; // noeud de depart
	int j; // noeud d'arrivé
};

struct graph_mco {
	int nbs;		  // nombre de sommets
	int nba;		  // nombre d'aretes
	int vcap;		  // capacité de vec
	int fcap;		  // capacité de func
	bool *call;		  // si la fontion a ete appele
	int *vu;		  // status de sommets
	fix_str *func;	  // noms de fonctions
	struct edge *vec; // vecteur d'aretes
};

graph_mco mcgragh(void);
void mcinsert_func(graph_mco *g, fix_str i);
void mcinsert_edge(graph_mco *g, int dep, int arr);
void mcdelete_graph(graph_mco *g);
int mcis_in(graph_mco g, fix_str func);
void mcprint(graph_mco g, int n, int color);
void mcdot_graph(graph_mco *g, bool main);
void mcfind_cycles(graph_mco *g);

#endif /* end of include guard: MATCOM_H */
