#include "pile.h"
#include <assert.h>
#include <stdlib.h>

pile_t init_pile(void)
{
	pile_t s;
	s.p = malloc((s.cap = 128) * sizeof(int));
	assert(s.p);
	s.top = -1;
	return s;
}

void push(pile_t *pile, int v)
{
	if (pile->top >= pile->cap) {
		pile->p = realloc(pile->p, (pile->cap += 128) * sizeof(int));
		assert(pile->p);
	}
	pile->top++;
	pile->p[pile->top] = v;
}

int pop(pile_t *pile)
{
	return pile->p[pile->top--];
}

int empty(pile_t pile)
{
	return pile.top < 0;
}

int top(pile_t pile)
{
	return pile.p[pile.top];
}

void free_pile(pile_t *s)
{
	if (s->p)
		free(s->p);
	s->p = NULL;
}
